: drop ] drop ;
: dup ] dup ;

: ( $ 0029 l ] word ] drop ;
: [ ;

: var c : [ ' lit l ] ,xt ] here ] i, ] ; [ $ 1 l ] cells ] allot ;
: dvar c : [ ' lit l ] ,xt ] here ] i, ] ; [ $ 2 l ] cells ] allot ;

macro : 1+ [ $ 9601 l ] i, ;
macro : 1- [ $ 9701 l ] i, ;

macro : 2* [ $ 0f88 l ] i, [ $ 1f99 l ] i, ;
macro : 2/ [ $ 9595 l ] i, [ $ 9587 l ] i, ;

macro : invert [ $ 9580 l ] i, [ $ 9590 l ] i, ;

: negate ] invert ] 1+ ;

( conditionals )
: 0= if [ $ 0000 l ; then [ $ ffff l ;
: = ] xor ] 0= ;

: cell+ [ $ 2 l ] + ;

( double operators )
: d@ ] dup ] cell+ ] @ ] swap ] @ ;
: d! ] swap ] over ] ! ] cell+ ] ! ;
: d1- ] swap ] dup if ] 1- ] swap ; then ] 1- ] swap ] 1- ;
: d1+ ] swap ] 1+ ] dup if ] swap ; then ] swap ] 1+ ;
: d0= ] 0= if ] 0= if [ $ ffff l ; then then [ $ 0000 l ;

( interrupts )
macro : inton [ $ 9478 l ] i, ;
macro : intoff [ $ 94f8 l ] i, ;

( demo )
: wait ] dup if ] 1- ] wait ; then ] drop ;
: portc! ] invert [ $ 35 l ] c! ;
: ant ] dup ] portc! [ $ ffff l ] wait ] 2* ;
: ants [ $ 0001 l ] or ] ant ] ant ] ant ] ants ;
: demo [ $ 0000 l ] ants ;

