;;; constants, variables


docon:
  dup_
  pop tosh
  pop tosl
  rcall ifetch
  ret


.set heap = $0100

;; tib

.dw link
.set link = pc - 1
.db 't','i','b',0

tib:
  rcall docon
  .dw heap
.set heap = heap + $80

;; wordbuf

.dw link
.set link = pc - 1
.db 'w','o','r','d','b','u','f',0

wordbuf:
  rcall docon
  .dw heap
.set heap = heap + $10

;; >in

.dw link
.set link = pc - 1
.db '>','i','n',0

toin:
  rcall docon
  .dw heap
.set heap = heap + 2

;; link

.dw link
.set link = pc - 1
.db 'l','i','n','k',0

linkk:
  rcall docon
  .dw heap
.set heap = heap + 2

;; mlink

.dw link
.set link = pc - 1
.db 'm','l','i','n','k',0

mlinkk:
  rcall docon
  .dw heap
.set heap = heap + 2

;; dict

.dw link
.set link = pc - 1
.db 'd','i','c','t',0

dict:
  rcall docon
  .dw heap
.set heap = heap + 2

;; dp

.dw link
.set link = pc - 1
.db 'd','p',0

dp:
  rcall docon
  .dw heap
.set heap = heap + 2

;; idp

.dw link
.set link = pc - 1
.db 'i','d','p',0

idp:
  rcall docon
  .dw heap
.set heap = heap + 2

;; source

.dw link
.set link = pc - 1
.db 's','o','u','r','c','e',0

source:
  rcall docon
  .dw heap
.set heap = heap + 2

;; tasks

.dw link
.set link = pc - 1
.db 't','a','s','k','s',0

tasks:
  rcall docon
  .dw heap
.set heap = heap + 2

.set datamem = heap


;;; eeprom variables

.eseg
.dw datamem
.dw codemem
.dw lastword
.dw lastmacro
.cseg

.set eheap = 0

;; ~dp

.dw link
.set link = pc - 1
.db '~','d','p',0

tildedp:
  rcall docon
  .dw eheap
.set eheap = eheap + 2

;; ~idp

.dw link
.set link = pc - 1
.db '~','i','d','p',0

tildeidp:
  rcall docon
  .dw eheap
.set eheap = eheap + 2

;; ~link

.dw link
.set link = pc - 1
.db '~','l','i','n','k',0

tildelink:
  rcall docon
  .dw eheap
.set eheap = eheap + 2

;; ~mlink

.dw link
.set link = pc - 1
.db '~','m','l','i','n','k',0

tildemlink:
  rcall docon
  .dw eheap
.set eheap = eheap + 2

.set eemem = eheap


;;; constants

;; bl

.dw link
.set link = pc - 1
.db 'b','l',0

bl:
  rcall docon
  .dw ' '

