;; find
;;
;; ( c-addr addr -- c-addr false | xt true )

.dw link
.set link = pc - 1
.db 'f','i','n','d',0

find:
  rcall over
  rcall over

  ; name starts at offset 1 in header
  rcall lit
  .dw 1
  rcall icells
  rcall plus

find_get_chars:
  rcall over
  rcall fetch
  rcall over
  rcall ifetch

find_check_chars:
  rcall over
  rcall over
  rcall cequal
  adiw tos,0
  drop_
  breq find_mismatch

  tst tosl
  breq find_found
  
  rcall over
  rcall swapbytes
  rcall over
  rcall swapbytes
  rcall cequal
  adiw tos,0
  drop_
  breq find_mismatch

  tst tosh
  breq find_found

  drop_
  drop_

  rcall lit
  .dw 1
  rcall icells
  rcall plus
  rcall swapp

  rcall lit
  .dw 1
  rcall cells
  rcall plus
  rcall swapp

  rjmp find_get_chars
  
find_found:
  drop_
  drop_
  rcall lit
  .dw 1
  rcall icells
  rcall plus
  rcall tor
  drop_
  drop_
  drop_
  rcall rfrom
  rcall true
  ret

find_mismatch:
  drop_
  drop_
  drop_
  drop_
  rcall ifetch

  adiw tos,0
  breq find_not_found

  rjmp find

find_not_found:
  ; tos already equals zero
  ret

