;; go

.dw link
.set link = pc - 1
.db 'g','o',0

abort:
go:
  ; init return stack pointer
  ldi temp0,high(ramend)
  out SPH,temp0
  ldi temp0,low(ramend)
  out SPL,temp0

  ; init parameter stack pointer
  ldi yh,high(ramend-return_stack_size+1)
  ldi yl,low(ramend-return_stack_size+1)

go_getline:
  rcall xquote
  .db '>',' ',0

  rcall tib
  rcall lit
  .dw $7e
  rcall accept

  rcall source
  rcall store
;  rcall lit
;  .dw $0000
;  rcall toin
;  rcall store

go_get_word:
  rcall bl
  rcall word

  adiw tos,0
  brne go_find_word

  drop_

  rcall xquote
  .db " ok",$0d,$0a,0

  rjmp go

go_find_word:
  rcall latest
  rcall fetch
  rcall find

  adiw tos,0
  brne go_word_found

go_word_not_found:
  drop_

  rcall space
  rcall type

  rcall lit
  .dw '?'
  rcall emit
  rcall cr
  rjmp go

go_word_found:
  drop_
  rcall execute

  rjmp go_get_word

